;******************************************************************************
;Date:	20th AUGUST 2001
;Aim:	simple demo to programm the input and output pins 
;	of PORT B for PIC16F84 microcontroller
;******************************************************************************
	LIST P=16F628		; list directive to define processor
	ERRORLEVEL -302
	include <p16F628.inc>	; processor specific variable definitions
	page
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;******************************************************************************
;	EQUATES/ DEFINITIONS
;******************************************************************************
RB3	EQU	3	
RB2	EQU	2
RB1	EQU	1
RB0	EQU	0
Dlybyte1	EQU	0x0e
Dlybyte2	EQU	0x0f	

;******************************************************************************
;main program start here
;******************************************************************************

		org	00h	; reset vector
		goto	start

;******************************************************************************
;	MAIN ROUTINE
;******************************************************************************
start	
	call	Port_Init	;call hardware setting subrotine
reloop
	btfss	PORTB,RB0	;check bit 0 at PORT B high? 
	call	LED_on1	;bit 0 low, call LED blink subrotine (bit 6)
	btfss	PORTB,RB1	;bit 0 high, check bit 1 at PORT B high?
	call	LED_on	;bit 1 low, call LED blink subrotine (bit 7)
	goto	reloop	;bit 1 high, go to reloop check again bit 0 and bit 1

;******************************************************************************
;Subroutine : Initialization of hardware and Port setting
;******************************************************************************
Port_Init	
	clrf	STATUS	; choose page 0 (Bank 0)
	bsf	STATUS, RP0	; select memory register page 1 (Bank 1)
	movlw	0x0f		;value used to intialize data direction
	movwf	TRISB		;set bit 0-3 (RB0 to RB3) as input and 
				;bit 4-7 (RB4 to RB7) as output fot PORT B
	bcf	STATUS, RP0	; go back to register page 0 (Blank 0)
	clrf	PORTB
	return

;******************************************************************************
;Subroutine : LED blinking
;******************************************************************************

LED_on	
	call	Dly1sec
	bsf	PORTB, 7	; set bit 7 LED on
	call	Dly1sec
	bcf	PORTB, 7	; turn bit 7 LED off
	return

LED_on1
	call	Dly1sec
	bsf	PORTB, 6	; set bit 6 LED on
	call	Dly1sec
	bcf	PORTB, 6	; turn bit 6 LED off
	return		

;******************************************************************************
;subroutine	: long delay loop
;******************************************************************************
Dly1sec
	movlw	0xff
	movwf	Dlybyte2
Dly10ms
	movlw	0xff
	movwf	Dlybyte1
Dly10msL2	
	decfsz	Dlybyte1,1
	goto	Dly10msL2
	decfsz	Dlybyte2,1
	goto	Dly10ms
	return
	end





















